	.file	"context-switch.c"
	.text
	.align	2
	.global	kerent
	.type	kerent, %function
kerent:
	@ args = 0, pretend = 0, frame = 0
	@ frame_needed = 1, uses_anonymous_args = 0


	@ get user's pc
	mov r1, lr 

	@ switch to system mode
	msr cpsr_c, #0xDF  @or #223

	@ push register contents onto users stack
	stmfd sp!, {r0-r14}

	@ save user's sp 
	mov r3, sp

	@ switch back to svc mode
	msr cpsr_c, #0xD3

	@ get spsr of user  
	msr r2, spsr

	@ push user's spsr and lr
	str r3!, {r2, r1}

	@ pop kernels stack
	ldmfd sp!, {r4-r14}


	.text
	.align	2
	.global	kerxit
	.type	kerxit, %function
kerxit:
	@ this is equi to activate, an entry point in the kernel to which it goes
	@ when its ready to restart the active task
	@ args = 0, pretend = 0, frame = 8
	@ frame_needed = 1, uses_anonymous_args = 0

	@ push kernel's registers
	stmfd sp!, {r4-r14}
	@ stmfd sp_svc!, {r0-r14} TODO
	@ switching to system mode
	msr cpsr_c, #0xDF 

	@ restore user's spsr and lr
	ldr r1, [sp, #0] @ lr
	ldr r2, [sp, #4] @ spsr
	sub sp, sp, #4

	@ restore user's registers
	ldmfd sp!, {r4-r14}

	@ switch back to svc mode
	msr cpsr, #0xD3

	@ restore user's spsr
	msr spsr, r2
	
	@ restore user's lr to continue execution; also put spsr_svc into cpsr
	movs pc, r1 


